/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the toggle widget.
***************************************************************/

/*toggle.c*/

#include <Xm/Xm.h>
#include <Xm/ToggleB.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

void toggleCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmAnyCallbackStruct *call_data;
/* handle state changes in the toggle. */
{
    Boolean set;
    Arg al[10];
    int ac;

    /* get the value of the set resource. */
    ac=0;
    XtSetArg(al[ac], XmNset, &set); ac++;
    XtGetValues(w,al,ac);

    if (set)
        printf("Toggle turned on\n");
    else
        printf("Toggle turned off\n");
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Widget toplevel, toggle;
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* Create the toggle button. */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
         XmStringCreateLtoR("Toggle Button",char_set)); ac++;
    toggle=XmCreateToggleButton(toplevel,"toggle",al,ac);
    XtManageChild(toggle);
    XtAddCallback (toggle, XmNvalueChangedCallback, toggleCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
