/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to extract the exposed rectangle from the
XEvent structure.
***************************************************************/

/* exposure.c */

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>

XtAppContext context;

Widget drawing_area;
Widget toplevel;

void exposeCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmAnyCallbackStruct *call_data;
{
    XExposeEvent *event;

    event=(XExposeEvent *) call_data->event;
    printf("Exposed rectangle: x=%d y=%d width=%d height=%d\n",
        event->x,event->y,event->width,event->height);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* default window size. */
    ac=0;
    XtSetArg(al[ac],XmNheight,400); ac++;
    XtSetArg(al[ac],XmNwidth,400); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a drawing area widget. */
    ac=0;
    drawing_area=XmCreateDrawingArea(toplevel,"drawing_area",al,ac);
    XtManageChild(drawing_area);    
    XtAddCallback(drawing_area,XmNexposeCallback,exposeCB,NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
